# fishpond.com.au music scraper
#
# Copyright  1999-2009 Readerware Corporation.  All Rights Reserved.

import  os
import  string

from    com.readerware.http import HTTPConnection

from    scrapers.scrapers import searchFor
from    scrapers.scrapers import searchForPlus
from    scrapers.scrapers import stripText
from    scrapers.scrapers import convertArtist
from    jarray import zeros, array
from    java.lang import String


def extract():
    global title,artist,label,composer,date,copyDate,running,artistLF
    global value,valueDate,copies,upc,isbn,lccn,dewey,userNumber
    global format,series,sound,rating,condition,category
    global location,keywords,played,pflag,eflag,comments
    global dateEntered,dataSource,cart,ordered
    global diskCount,artistURL,conductor
    global trackTitles,trackArtists,trackWriters,trackTimes
    global user1,user2,user3,user4,user5,user6,user7,user8,user9,user10
    global usedprice,usedcount,collectibleprice,collectiblecount
    global newprice,newcount,listprice,salesrank,available
    global buyerwaiting,editionNumber,image,fullDateFormat,source


    # Defaults
    pflag               = "Y"
    eflag               = "Y"
    ordered             = "N"
    sound               = "Stereo"
    format              = "CD"
    usedprice           = ""
    usedcount           = ""
    collectibleprice    = ""
    collectiblecount    = ""
    newprice            = ""
    newcount            = ""
    listprice           = ""
    salesrank           = ""
    available           = "Y"
    buyerwaiting        = "N"
    artistLF            = ""


    i = string.find(source, "> - did not match any products.<")

    if i != -1:
        source = searchFor(source, "force exception")
        source = searchFor(source, "force exception")
        return

    i = string.find(source, "Products meeting the search criteria")

    if i != -1:
        source = searchFor(source, "force exception")
        source = searchFor(source, "force exception")
        return


    # Find marketplace pricing
    marketinfo = source


    # Main extraction
    source = searchForPlus(source, "<!-- body_text //-->")


    # Find Title
    source = searchForPlus(source, "id=\"product_title\"")
    source = searchForPlus(source, ">")
    i = string.find(source, "<")
    title = stripText(source[0:i])

    i = string.rfind(title, "[")

    if i != -1:
        title = stripText(title[0:i])


    # Find Artist
    i = string.find(source, "author=")

    if (i != -1):
        source = searchForPlus(source, "author=")
        source = searchForPlus(source, "\">")
        i = string.find(source, "<")
        artist = stripText(source[0:i])
        artist = convertArtist(artist)


    # Find Image
    tag = "class=\"product_img\""
    i = string.find(source, tag)

    if i != -1:
        image = searchForPlus(source, tag)
        image = searchForPlus(image, "src=\"")
        i = string.find(image, "\"")
        image = stripText(image[0:i])

        i = string.find(image, "dvd-no-image")

        if i != -1:
            image = ""


    # Find Price
    i = string.find(source, "class=\"productSpecialPrice\"")

    if i != -1:
        source = source[i:]
        source = searchFor(source, "$")
        i = string.find(source, "<")
        value = stripText(source[0:i])

        if source[i:].startswith("</s>") == 1:
            listprice = value
            source = searchForPlus(source, "$")
            source = searchFor(source, "$")
            i = string.find(source, "<")
            value = stripText(source[0:i])


    # Find Label
    i = string.find(source, ">Label:")

    if (i != -1):
        label = searchForPlus(source, ">Label:")
        label = searchForPlus(label, ">")
        label = searchForPlus(label, "<td>")
        i = string.find(label, "<")
        label = stripText(label[0:i])


    # Find Tracks
    tag = ">listen to"
    i = string.find(source, tag)

    if i == -1:
        tag = "class=\"productListing-data\""
        i = string.find(source, tag)

    if i != -1:
        source = searchForPlus(source, tag)
        i = string.find(source, "</table>")
        disks = stripText(source[0:i])

        if string.find(disks, ">Disc 1<") == -1:
            disks = ">Disc 1<" + disks

        trackList = []
        artistList = []
        diskCount = 0

        while (searchFor(disks, ">Disc ") != None):
            diskCount = diskCount + 1
            disks = searchForPlus(disks, ">Disc ")
            i = string.find(disks, "<")
            diskid = "%02d" % stripText(disks[0:i])

            i = string.find(disks, ">Disc ")

            if i != -1:
                tracks = stripText(disks[0:i])
            else:
                tracks = stripText(disks)

            trackIndex = 1

            while (searchFor(tracks, "class='productListing-data'") != None):
                trackid = "%02d" % trackIndex
                tracks = searchForPlus(tracks, "class='productListing-data'")
                tracks = searchForPlus(tracks, ">")
                i = string.find(tracks, "<")
                track = stripText(tracks[0:i])

                i = string.find(track, " - ")
                trackArtist = ""

                if i != -1:
                    trackArtist = stripText(track[i+3:])
                    track = stripText(track[0:i])

                trackList.append(diskid + "-" + trackid + "-" + track)
                trackIndex = trackIndex + 1

                if trackArtist != "":
                    trackArtist = convertArtist(trackArtist)
                    artistList.append(diskid + "-" + trackid + "-" + trackArtist)
                else:
                    artistList.append(diskid + "-" + trackid + "-")

        trackList.sort()
        trackTitles = array(trackList, String)
        artistList.sort()
        trackArtists = array(artistList, String)
    else:
        i = string.find(source, ">Track Listing<")

        if i != -1:
            source = searchForPlus(source, ">Track Listing<")
            i = string.find(source, "</table>")
            disks = stripText(source[0:i])

            trackList = []
            artistList = []
            diskCount = 0

            while (searchFor(disks, "Disc ") != None):
                diskCount = diskCount + 1
                disks = searchForPlus(disks, "Disc ")
                i = string.find(disks, ":")
                diskid = "%02d" % stripText(disks[0:i])

                i = string.find(disks, ">Disc ")

                if i != -1:
                    tracks = stripText(disks[0:i])
                else:
                    tracks = stripText(disks)

            trackIndex = 1

            while (searchFor(tracks, ". ") != None):
                trackid = "%02d" % trackIndex
                tracks = searchForPlus(tracks, ". ")
                i = string.find(tracks, "<")
                track = stripText(tracks[0:i])

                i = string.find(track, " - ")
                trackArtist = ""

                if i != -1:
                    trackArtist = stripText(track[i+3:])
                    track = stripText(track[0:i])

                trackList.append(diskid + "-" + trackid + "-" + track)
                trackIndex = trackIndex + 1

                if trackArtist != "":
                    trackArtist = convertArtist(trackArtist)
                    artistList.append(diskid + "-" + trackid + "-" + trackArtist)
                else:
                    artistList.append(diskid + "-" + trackid + "-")

        trackList.sort()
        trackTitles = array(trackList, String)
        artistList.sort()
        trackArtists = array(artistList, String)


    # Find Format
    i = string.find(source, ">Format:")

    if i != -1:
        format = searchForPlus(source, ">Format:")
        format = searchForPlus(format, "<td>")
        i = string.find(format, "<")
        format = stripText(format[0:i])

        i = string.find(format, ";")

        if i != -1:
            sound = stripText(format[i+1:])
            format = stripText(format[0:i])


    # Find UPC
    i = string.find(source, ">UPC:<")

    if i != -1:
        upc = searchForPlus(source, ">UPC:<")
        upc = searchForPlus(upc, "<td>")
        i = string.find(upc, "<")
        upc = stripText(upc[0:i])


    # Find Release Date
    i = string.find(source, ">Release Date:")

    if i != -1:
        date = searchForPlus(source, ">Release Date:")
        date = searchForPlus(date, "<td>")
        i = string.find(date, "<")
        date = stripText(date[0:i])

        if fullDateFormat == "false":
            i = string.rfind(date, " ")

            if i != -1:
                date = stripText(date[i+1:])


    # Find Comments
    comments = ""
    i = string.find(source, ">Performer Notes")

    if i != -1:
        comments = searchForPlus(source, ">Performer Notes")
        comments = searchForPlus(comments, "<ul>")
        i = string.find(comments, "</ul>")
        comments = stripText(comments[0:i])

        comments = string.replace(comments, "<br>", "\n")
        comments = string.replace(comments, "<br />", "\n")
        comments = string.replace(comments, "<li>", "\n\n")
        comments = string.replace(comments, "</li>", "")

    i = string.find(source, "Reviews</div>")

    if i != -1:
        reviews = searchForPlus(source, "Reviews</div>")
        i = string.find(reviews, "<table")
        reviews = "Reviews\n" + stripText(reviews[0:i])

        reviews = string.replace(reviews, "<p>", "\n")
        reviews = string.replace(reviews, "<br>", "\n")
        reviews = string.replace(reviews, "<br />", "\n")
        reviews = string.replace(reviews, "</b>", "")

        if comments == "":
            comments = reviews
        else:
            comments = comments + "\n\n" + reviews




# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*


try:
    extract()
finally:
    if os.path.exists("scrapers/awuserexit.py"):
        execfile("scrapers/awuserexit.py") in globals()
