# CD Baby music scrpaer
#
# Copyright  1999-2009 Readerware Corporation.  All Rights Reserved.

import  os
import  string

from    com.readerware.http import HTTPConnection

from    scrapers.scrapers import searchFor
from    scrapers.scrapers import searchForPlus
from    scrapers.scrapers import stripText
from    scrapers.scrapers import convertArtist
from    jarray import zeros, array
from    java.lang import String


def extract():
    global title,artist,label,composer,date,copyDate,running,artistLF
    global value,valueDate,copies,upc,isbn,lccn,dewey,userNumber
    global format,series,sound,rating,condition,category
    global location,keywords,played,pflag,eflag,comments
    global dateEntered,dataSource,cart,ordered
    global diskCount,artistURL,conductor
    global trackTitles,trackArtists,trackWriters,trackTimes
    global user1,user2,user3,user4,user5,user6,user7,user8,user9,user10
    global usedprice,usedcount,collectibleprice,collectiblecount
    global newprice,newcount,listprice,salesrank,available
    global buyerwaiting,editionNumber,image,fullDateFormat,source


    # Defaults
    pflag               = "Y"
    eflag               = "Y"
    ordered             = "N"
    sound               = "Stereo"
    format              = "CD"
    usedprice           = ""
    usedcount           = ""
    collectibleprice    = ""
    collectiblecount    = ""
    newprice            = ""
    newcount            = ""
    listprice           = ""
    salesrank           = ""
    available           = "Y"
    buyerwaiting        = "N"
    artistLF            = ""


    # Find Artist web site
    i = string.find(source, ">Official Website<")

    if i != -1:
        artistURL = stripText(source[i-100:])
        artistURL = searchForPlus(artistURL, " href=\"")
        i = string.find(artistURL, "\"")
        artistURL = stripText(artistURL[0:i])


    # Find Image
    i = string.find(source, "class=\"album-cover\"")

    if i != -1:
        image = searchForPlus(source, "class=\"album-cover\"")
        image = searchForPlus(image, " src=\"")
        i = string.find(image, "\"")
        image = "http://www.cdbaby.com" + stripText(image[0:i])

        i = string.find(image, "music-no-image")

        if i != -1:
            image = ""

    # Find Title
    i = string.find(source, "class=\"album-name\"")

    if i != -1:
        source = searchForPlus(source, "class=\"album-name\"")
        source = searchForPlus(source, ">")
        i = string.find(source, "<")
        title = stripText(source[0:i])


    # Find Artist
    i = string.find(source, "class=\"artist-name\"")

    if i != -1:
        source = searchForPlus(source, "class=\"artist-name\"")
        source = searchForPlus(source, ">")
        i = string.find(source, "</div")
        artist = stripText(source[0:i])

        if artist.startswith("<a href") == 1:
            artist = searchForPlus(artist, "\">")
            i = string.find(artist, "<")
            artist = stripText(artist[0:i])

        artist = convertArtist(artist)


    # Find UPC
    i = string.find(source, "class=\"album-barcode\"")

    if i != -1:
        source = searchForPlus(source, "class=\"album-barcode\"")
        source = searchForPlus(source, ">")
        source = searchForPlus(source, "(")
        i = string.find(source, ")")
        upc = stripText(source[0:i])


    # Find Label
    i = string.find(source, "class=\"album-label\"")

    if i != -1:
        source = searchForPlus(source, "class=\"album-label\"")
        source = searchForPlus(source, ">")
        source = searchForPlus(source, ":")
        i = string.find(source, "<")
        label = stripText(source[0:i])


    # Find Value
    i = string.find(source, "class=\"format-message\"")

    if i != -1:
        source = searchForPlus(source, "class=\"format-message\"")
        source = searchFor(source, "$")
        i = string.find(source, "<")
        value = stripText(source[0:i])


    # Find Tracks
    i = string.find(source, "id=\"tracks-display\"")

    if i != -1:
        source = searchForPlus(source, "id=\"tracks-display\"")
        source = searchFor(source, "</tr>")
        i = string.find(source, "</table>")
        disks = stripText(source[0:i+6])

        if string.find(disks, ">Disc: ") == -1:
            disks = ">Disc: 1<" + disks

        trackList = []
        artistList = []
        timeList = []
        diskCount = 0

        while (searchFor(disks, ">Disc: ") != None):
            diskCount = diskCount + 1
            disks = searchForPlus(disks, ">Disc: ")
            i = string.find(disks, "<")
            diskid = "%02d" % stripText(disks[0:i])

            i = string.find(disks, "</dl>")
            tracks = stripText(disks[0:i])
            trackIndex = 1

            while (searchFor(tracks, "padding-left:15px;\">") != None):
                tracks = searchForPlus(tracks, "padding-left:15px;\">")
                i = string.find(tracks, "<")
                track = stripText(tracks[0:i])

                trackid = "%02d" % trackIndex
                i = string.find(track, " - ")
                trackArtist = ""

                if i != -1:
                    trackArtist = stripText(track[i+3:])
                    track = stripText(track[0:i])

                trackList.append(diskid + "-" + trackid + "-" + track)
                trackIndex = trackIndex + 1

                if trackArtist != "":
                    trackArtist = convertArtist(trackArtist)
                    artistList.append(diskid + "-" + trackid + "-" + trackArtist)
                else:
                    artistList.append(diskid + "-" + trackid + "-")

                i = string.find(tracks, "_lblTrackLength\">")

                if i != -1:
                    tracks = searchForPlus(tracks, "_lblTrackLength\">")
                    i = string.find(tracks, "<")
                    trackTime = stripText(tracks[0:i])
                else:
                    trackTime = ""

                timeList.append(diskid + "-" + "%02d" % trackid + "-" + trackTime)
    


        trackList.sort()
        trackTitles = array(trackList, String)
        artistList.sort()
        trackArtists = array(artistList, String)
        timeList.sort()
        trackTimes = array(timeList, String)


    # Find Comments
    i = string.find(source, "class=\"album-notes\"")

    if (i != -1):
        source = searchForPlus(source, "class=\"album-notes\"")
        source = searchForPlus(source, "<span ")
        source = searchForPlus(source, "\">")
        i = string.find(source, "</span></p>")
        comments = source[0:i]

        comments = string.replace(comments, "\n ", "")
        comments = string.replace(comments, "\n", "")
        comments = string.replace(comments, "<br />", "\n")
        comments = string.replace(comments, "<h3>", "")
        comments = string.replace(comments, "</h3>", "\n\n")
        comments = string.replace(comments, "<p>", "")
        comments = string.replace(comments, "</p>", "")
        comments = string.replace(comments, "\xE2\x80\x93", "-")
        comments = string.replace(comments, "\xE2\x80\x99", "'")
        comments = string.replace(comments, "\xE2\x80\x9C", "\"")
        comments = string.replace(comments, "\xE2\x80\x9D", "\"")



try:
    extract()
finally:
    if os.path.exists("scrapers/awuserexit.py"):
        execfile("scrapers/awuserexit.py") in globals()
